<?php

namespace Teknisa\FIS\Services;

use Teknisa\FIS\Factories\Fis06900TipoDeItemFactory;
use Teknisa\Libs\Util\Environment;

class Fis06900TipoDeItemService{
    protected $entityManager;
    protected $environment;
    protected $nrorg;
    protected $factoryTipoDeItem;

    public function __construct(\Doctrine\ORM\EntityManager $entityManager, Environment $environment, Fis06900TipoDeItemFactory $factoryTipoDeItem) {
        $this->entityManager = $entityManager;
        $this->environment = $environment;
        $this->nrorg = $environment->getNrorgTrab();
        $this->factoryTipoDeItem = $factoryTipoDeItem;
    }

    public function deletaTipoItemLivroMag($cdlivromag) {
        $this->factoryTipoDeItem->deletaTipoItemLivroMag(array(
            "CDLIVROMAG" => $cdlivromag,
            "NRORG" => $this->nrorg
        ));
    }

    public function saveTipoItemLivroMag($row, $cdlivromag){
        $currentTime = $this->environment->getCurrentTime()->format("d/m/Y H:i:s");
        $operador = $this->environment->getCdOperador();

        $this->factoryTipoDeItem->saveTipoItemLivroMag(array(
            "NRORG" => $this->nrorg,
            "CDLIVROMAG" => $cdlivromag,
            "CDTPITEMPROD" => $row['CDTPITEMPROD'],
            "NMTPITEMPROD" => $row['NMTPITEMPROD'],
            "DTINCLUSAO" => $currentTime,
            "NRORGINCLUSAO" => $this->nrorg,
            "CDOPERINCLUSAO" => $operador
        ));
    }
}