var Fis07800_DacAl_Controller = function(General, ScreenService, templateManager, Messages_fiscal, ObrigacoesAcessoriasUtil) {
    
    var self = this;
    
    self.addAgendamento = function(widget){
        widget.newRow(); 
        widget.getField('DTREFINI').isVisible = true;
    };
    
    self.cancelAgendamento = function(args){
        General.backOrCancel(args); 
        General.changeWidgetAcessibility(args.owner.widget.widgets, true);
        args.owner.widget.getField('DTREFINI').isVisible = true;
    };
    
    self.editAgendamento = function(widget){
        General.edit(widget); 
        this.periodicidadeOnChange(widget);
    };
    
    self.saveAgendamento = function(widget){
        if (widget.isValid()) {
		    var d1 = new Date(moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY HH:mm').format('MM/DD/YYYY HH:mm'));
            var d2 = new Date(moment().format('MM/DD/YYYY HH:mm'));
            
		    if(d1.getTime() > d2.getTime()){
                if(((widget.currentRow.CDINSCESTA == '') || (widget.currentRow.CDINSCESTA == null)) && (widget.currentRow.CDEMPRESA)){
                    widget.currentRow.CDINSCESTA = "T";
                }
                
                widget.currentRow.NRORG = getLocalVar('NRORG');
                
                General.callRestEngine('fis_acessorias#/saveAgendamentoDacAl','Row', widget.currentRow).then(
                    function(success){
                        General.changeWidgetAcessibility(widget.widgets, true);
                        ScreenService.showMessage('Agendado com sucesso.');
                        ScreenService.goBack();
                        widget.getField('DTREFINI').isVisible = true;
                        widget.reload();
                    },
                    function(error){
                        ScreenService.showMessage(error.data.error);
                    }
                );
		    } else {
		        ScreenService.showMessage('A Data de Agendamento deve ser maior que a data atual, e não pode ser igual a hora atual!');
		    }
            
        } else {
			// @todo create messages class
			ScreenService.showMessage("Preencha todos os campos corretamente!");
		}
    };
    
    self.downloadArquivoAgendado = function(spedWidget) {
        var downloadRoute;
        var fileName;
        
        if(spedWidget.hasCheckedRows()){
            var rows = spedWidget.getCheckedRows();
            rows.forEach(function(row){
                downloadRoute = window.serviceUrls.filter(function(x){return x.package == 'fis';})[0].baseUrl + "/downloadArquivoAgendamento?requestType=Row&row[DSARQUIVO]=";
                fileName = row.NMARQUIVO;
                
                window.open(downloadRoute + fileName);
            });
        } 
        else {
            var row = spedWidget.currentRow;
            downloadRoute = window.serviceUrls.filter(function(x){return x.package == 'fis';})[0].baseUrl + "/downloadArquivoAgendamento?requestType=Row&row[DSARQUIVO]=";
            fileName = row.NMARQUIVO;
            
            window.open(downloadRoute + fileName);
        }
        
    };
    
    self.deleteAgendamento = function(widget){
        widget.currentRow.NRORG = getLocalVar('NRORG');
        
        ScreenService.confirmMessage(ScreenService.i18n('Deletar Agendamento?'), 'question', function (success) {
        	General.callRestEngine('fis_acessorias#/deleteAgendamentoDacAl','Row', widget.currentRow).then(
                function(success){
                    ScreenService.showMessage('Deletado com sucesso.');
                    ScreenService.goBack();
                    widget.reload();
                },
                function(error){
                    ScreenService.showMessage(error.data.error);
                }
            );
        });
    };
    
    self.periodicidadeOnChange = function(widget){
        if(widget.currentRow.IDPERIAGEN == 0){
            widget.getField('DTREFINI').isVisible = true;
        }
        else if(widget.currentRow.IDPERIAGEN == 1){
            widget.getField('DTREFINI').isVisible = false;
            if((widget.currentRow.DTAGENDAMENTO) && widget.currentRow.DTAGENDAMENTO != ""){
                widget.currentRow.DTREFINI = moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY').format('DD/MM/YYYY');
            }
        }
        else if(widget.currentRow.IDPERIAGEN == 2){
            widget.getField('DTREFINI').isVisible = false;
            if((widget.currentRow.DTAGENDAMENTO) && widget.currentRow.DTAGENDAMENTO != ""){
                widget.currentRow.DTREFINI = moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY').subtract(1, 'M').format('DD/MM/YYYY');
            }
        }
        widget.getField('DTREFINI').reload();
    };
    
    /*
     * Função para a chamada da função de exportação.
     */
    this.exportarDacAl = function(dacAlWidget) {
        // Verifica se todos os campos obrigatórios foram preenchidos.
        if (dacAlWidget.isValid()) {
            // Verifica se a parametrização para exportação foi verificada.
            if (!parametrizacaoWasLoaded(dacAlWidget)) {
                return;
            }

            // Atribui aos fields da widget principal, os vaores da widget
            // 'parametrosGeraidDacAl'
            var parametrosWidget = templateManager.container.getWidget('parametrosGeraisDacAl');
            preencheFieldsOcultosWidgetPrincipal(dacAlWidget, parametrosWidget);
            var row = dacAlWidget.currentRow;            
            var route = "fis#/exportarDacAl";
            var message = Messages_fiscal.EXPORTANDO_DAC_AL;
            ObrigacoesAcessoriasUtil.exportarArquivo(row, route, message);
        }
    };

    var parametrizacaoWasLoaded = function(dacAlWidget) {
        var parametrizacaoWasLoaded;
        var parametrosWidget;
        var cdempresa = dacAlWidget.currentRow.CDEMPRESA;
        parametrosWidget = templateManager.container.getWidget('parametrosGeraisDacAl');
        // Valida se a propriedade está setada para a empresa selecionada.
        parametrizacaoWasLoaded = parametrosWidget.empresasLoaded[cdempresa];

        // Verifica se a widget de parametrização foi aberta antes de exportar o arquivo.
        if (!parametrizacaoWasLoaded) {
            // Muda a propriedade para que seja obrigatório que a parametrização seja informada.
            parametrosWidget.parametersRequired = true;
            // Exibe a mensagem que indica que os parâmetros devem ser verificados.
            ScreenService.showMessage(Messages_fiscal.PARAMETROS_GERAIS_NAO_INFORMADOS_ERROR)
            .then(function() {
                // Abre a swipe da widget de parâmetros.
                openTabParametrosGerais(dacAlWidget);
            });
            // Retorna false, indicando que a parametrização não foi previamente conferida.
            return false;
        }
        // Retorna true caso contrário, indicando que a parametrização foi previamente conferida.
        return true;
    };
    
    /*
     * Função para abrir o formulário com as parametrizações do DAC-AL.
     * Altera o parâmetro "wasLoaded" da widget, que indica se a parametrização
     * foi revisada antes do arquivo ter sido exportado.
     */
    var openTabParametrosGerais = function(dacAlWidget) {
        
        // Seleciona a widget conforme o arquivo selecionado.
        var parametrosWidget = templateManager.container.getWidget('parametrosGeraisDacAl');
        // Recarrega os dados parametrizados.
        parametrosWidget.reload().then(function() {
            // Redesenha a widget, fazendo com que apareçam os dados carregados.
            parametrosWidget.redraw();
        });
        // Abre a widget da tabbed 'parametrosGerais'
        dacAlWidget.currentWidget = parametrosWidget;
        parametrosWidget.activate();
    };

    /*
     * Função para salvar a parametrização informada pelo usuário.
     * Ou apenas confirmar os valores dos Fields, caso já existam os campos
     * gravados.
     */
    this.salvarParametrizacao = function(parametrosWidget) {
        // Verifica se todos os dados requeridos foram preenchidos.
        if (parametrosWidget.isValid()) {
            var dacAlWidget = templateManager.container.getWidget("Dac-Al");
            // Abaixo, é verificado se os 3 fiels abaixo contém números
            var versao = parametrosWidget.currentRow.VERSAO;
            var release = parametrosWidget.currentRow.RELEASE;
            var sbrelease = parametrosWidget.currentRow.SBRELEASE;
            var aidf = parametrosWidget.currentRow.AIDF;
            // Trata aidf caso for 'undefined', se continuar, não será possível compará-lo abaixo.
            if(aidf == undefined)
                aidf = "";
            // Não é possível saber o tamanho de variável tipo Number. Por isso a conversão.
            aidf = aidf.toString();
            // Validadação especial para o campo numério AIDF.
            if(aidf.length == 0){
                aidf = true;
            }else{
                if(isNumber(aidf)){
                    aidf = true;
                }else{
                    aidf = false;
                }
            }
            if(isNumber(versao) && isNumber(release) && isNumber(sbrelease) && aidf){
                preencheFieldsOcultosWidgetPrincipal(dacAlWidget, parametrosWidget);
                // Chama a função para salvar os dados.
                parametrosWidget.saveRow()
                .then(function() {
                    
                    // Seta os parametros como verificados pelo usuário.
                    setParametersVerified(parametrosWidget);
    
                    // Altera a widget ativa para a principal.
                    dacAlWidget.activate();
                    dacAlWidget.currentWidget = dacAlWidget;
    
                    // Verifica se os parâmetros foram exibidos devido a uma
                    // tentativa de exportar o DAC-AL. Em caso positivo, tenta
                    // exportar o DAC-AL novamente.
                    if (parametrosWidget.parametersRequired) {
                        self.exportarDacAl(dacAlWidget);
                        // Retira a necessidade de exportar automaticamente ao
                        // abrir a parametrização novamente.
                        parametrosWidget.parametersRequired = false;
                    }
                });
            }else{
                ScreenService.showMessage("Os campos Versão, Release, Sub-Release e AIDF devem ser numéricos");
            }
        }
    };    
    
    /**
     * Função auxiliar para verificar se fields são numéricos
     */
    var isNumber = function(n) {
        return !isNaN(parseFloat(n)) && isFinite(n);
    };    
        
    /**
     * Função auxiliar, que preenche os fields ocultos com os valores da 
     * widget 'parametrosGeraisDacAl'
     */
    var preencheFieldsOcultosWidgetPrincipal = function(dacAlWidget, parametrosWidget){
        dacAlWidget.currentRow.CDGRUPPROD = parametrosWidget.currentRow.CDGRUPPROD;
        dacAlWidget.currentRow.VERSAO = parametrosWidget.currentRow.VERSAO; 
        dacAlWidget.currentRow.RELEASE = parametrosWidget.currentRow.RELEASE;
        dacAlWidget.currentRow.SBRELEASE = parametrosWidget.currentRow.SBRELEASE;
        dacAlWidget.currentRow.TPDEC = parametrosWidget.currentRow.TPDEC; 
        dacAlWidget.currentRow.PDEC = parametrosWidget.currentRow.PDEC; 
        dacAlWidget.currentRow.INDMOV = parametrosWidget.currentRow.INDMOV; 
        dacAlWidget.currentRow.INDENC = parametrosWidget.currentRow.INDENC; 
        dacAlWidget.currentRow.GUIA = parametrosWidget.currentRow.GUIA; 
        dacAlWidget.currentRow.APURAC = parametrosWidget.currentRow.APURAC; 
        dacAlWidget.currentRow.SISTEMA = parametrosWidget.currentRow.SISTEMA; 
        dacAlWidget.currentRow.CALC = parametrosWidget.currentRow.CALC; 
        dacAlWidget.currentRow.AIDF = parametrosWidget.currentRow.AIDF; 
        dacAlWidget.currentRow.REGANUAL = parametrosWidget.currentRow.REGANUAL;        
    }; 
    
    /*
     * Função auxiliar que seta na widget de parâmetros a propriedade indicando
     * que a parametrização foi verificada pelo usuário.
     */
    var setParametersVerified = function(parametrosWidget) {
        var dacAlFiscalIsSelected = parametrosWidget.name == "parametrosGeraisDacAl";
        var currentRow = parametrosWidget.currentRow;
        // Seta a propriedade que indica se a parametrização foi verificada.
        if (dacAlFiscalIsSelected) {
            var dacAlWidget = templateManager.container.getWidget("Dac-Al");
            // Verifica se o objeto já foi criado pra esta empresa.
            if (!parametrosWidget.empresasLoaded[currentRow.CDEMPRESA]) {
                parametrosWidget.empresasLoaded[currentRow.CDEMPRESA] = {};
            }
            // Seta o parâmetro para a empresa selecionada.
            parametrosWidget.empresasLoaded[currentRow.CDEMPRESA] = true;
            //dacAlWidget.currentRow.REG1400 = (Array.isArray(currentRow.CDOBRIGARRAY) && currentRow.CDOBRIGARRAY.indexOf(4) !== -1);
        }
        else {
            // Modifica a propriedade indicando que a parametrização foi
            // aberta para a empresa selecionada.
            parametrosWidget.empresasLoaded[currentRow.CDEMPRESA] = true;
        }
    };    

    /*
     * Função para alterar a propriedade readOnly do campo de inscrição,
     * conforme a inserção da empresa.
     */
    this.empresaOnChange = function(dacAlWidget) {
        // Valida inscrição estadual.
        ObrigacoesAcessoriasUtil.empresaOnChange(dacAlWidget);

        // Variável booleana que é setada como true caso alguma Empresa
        // tenha sido selecionada.
        var inscricaoEmpresaIsSelected = !!dacAlWidget.currentRow.CDEMPRESA;
        var parametrosWidget = templateManager.container.getWidget('parametrosGeraisDacAl');
        
        // Coloca a visibilidade da tabbed 'parametrosGerais' como true,
        // caso alguma Empresa esteja selecionada.
        parametrosWidget.enabled = inscricaoEmpresaIsSelected;
    };
   
    /*
     * Função para setar a currentRow da widget de parâmetros após o carregamento dos dados.
     * Altera, também, a propriedade que indica se já havia uma parametrização cadastrada.
     */
    this.setLoadedParameters = function(parametrosWidget) {
        var dacAlWidget = templateManager.container.getWidget("Dac-Al");
        // Verifica se há alguma parametrização retornada.
        if (parametrosWidget.dataSource.data.length > 0) {
            // Seta a currentRow como o primeiro dado no array retornado.
            parametrosWidget.moveToFirst();
            // Seta nas currentRows os valores das colunas originais
            obterValoresColunasOriginais(parametrosWidget);
            // Redesenha, na widget, os fields com os valores
            parametrosWidget.redraw();
        }
        else {
            // Seta a widget em modo de novo dado, para inserir a parametrização.
            parametrosWidget.newRow();
            parametrosWidget.currentRow.CDEMPRESA = dacAlWidget.currentRow.CDEMPRESA;
        }
        // Seta o nome da empresa no campo select de empresa, devido a um
        // comportamento que não exibe o nome da empresa correspondente ao código.
        parametrosWidget.currentRow.NMEMPRESA = dacAlWidget.currentRow.NMEMPRESA;
    };  
    
    /**
     * Função auxiliar, para atribuir aos fields da widget, os valores das
     * fields genéricas.
     */
    var obterValoresColunasOriginais = function(parametrosWidget){
        parametrosWidget.currentRow.CDGRUPPROD = parametrosWidget.currentRow.CDCAMPO1;
        parametrosWidget.currentRow.VERSAO = parametrosWidget.currentRow.CDCAMPO2; 
        parametrosWidget.currentRow.RELEASE = parametrosWidget.currentRow.CDCAMPO3;
        parametrosWidget.currentRow.SBRELEASE = parametrosWidget.currentRow.CDCAMPO4;
        parametrosWidget.currentRow.TPDEC = parametrosWidget.currentRow.CDCAMPO5; 
        parametrosWidget.currentRow.PDEC = parametrosWidget.currentRow.CDCAMPO6; 
        parametrosWidget.currentRow.INDMOV = parametrosWidget.currentRow.CDCAMPO7; 
        parametrosWidget.currentRow.INDENC = parametrosWidget.currentRow.CDCAMPO8; 
        parametrosWidget.currentRow.GUIA = parametrosWidget.currentRow.CDCAMPO9; 
        parametrosWidget.currentRow.APURAC = parametrosWidget.currentRow.CDCAMPO10;    
        parametrosWidget.currentRow.SISTEMA = parametrosWidget.currentRow.CDCAMPO11; 
        parametrosWidget.currentRow.CALC = parametrosWidget.currentRow.CDCAMPO12; 
        parametrosWidget.currentRow.REGANUAL = parametrosWidget.currentRow.CDCAMPO13;           
    }; 
    
    /*
     * Função para setar os parâmetros como verificados ao sair da widget.
     */
    this.beforeExitParametrosGerais = function(parametrosWidget) {
        // Seta a parametrização como verificada somente se a widget não
        // estiver em modo de inserção, mas sim de edição.
        if (!parametrosWidget.isNewRow()) {
            setParametersVerified(parametrosWidget);
        }
    };    

    /*
     * Função para salvar o valor de um field com outro nome na currentRow.
     * Chamada pela parametrização do SPED Contribuições, devido ao fato deste
     * utilizar uma tabela genérica e campos com nomes genéricos, sendo necessário
     * salvar o valor com o nome original do campo.
     * Utilizado por fields select-native também devido ao fato do outData não
     * funcionar da maneira devida neste caso.
     */
    this.setCurrentRowValue = function(field) {
        // Seta a propriedade na currentRow com o mesmo valor do field.
        field.widget.currentRow[field.originalColumn] = field.value();
    };    

    this.saveEspecDocFisc = function(especDocFiscGrid) {
        if(especDocFiscGrid.backupRow && !especDocFiscGrid.currentRow.__is_new){
            especDocFiscGrid.currentRow.CDESPECDOCFISC = especDocFiscGrid.backupRow.CDESPECDOCFISC;
        }
        General.saveCrud( especDocFiscGrid );
    };
    
    this.cdespecdocfiscOnChange = function(cdespecdocfiscField) {
        cdespecdocfiscField.widget.currentRow.CDESPECDOCFISC = General.fill(cdespecdocfiscField.value(), 10);
    };

};

Configuration(function(ContextRegister){
    ContextRegister.register('Fis07800_DacAl_Controller', Fis07800_DacAl_Controller);
});